﻿namespace Wzorce
{
    static class Log //wzorzec singleton
    {
        static Log()
        {
            Console.WriteLine("Utworzono rejestr zdarzeń");
        }

        private static List<string> komunikaty = new List<string>();

        public static void Dodaj(string komunikat)
        {
            komunikaty.Add(DateTime.Now.ToString() + " " + komunikat);
        }

        private const string nazwaPliku = "log.txt";

        public static void Zapisz()
        {
            File.WriteAllLines(nazwaPliku, komunikaty);
        }
    }


    internal class Program
    {
        static void Main(string[] args)
        {
            Log.Dodaj("Uruchomienie aplikacji");

            new DalekaKlasaGłębokoWBibliotekach().Cośtam();

            Log.Dodaj("Zatrzymanie aplikacji");
            Log.Zapisz();
        }
    }

    class DalekaKlasaGłębokoWBibliotekach
    {
        public void Cośtam()
        {
            Log.Dodaj("Metoda Cośtam w dalekiej klasie");
        }
    }

}
